/*
 * Copyright 2010-2019 JetBrains s.r.o. and Kotlin Programming Language contributors.
 * Use of this source code is governed by the Apache 2.0 license that can be found in the license/LICENSE.txt file.
 */

package org.jetbrains.kotlin.nj2k;

import com.intellij.testFramework.TestDataPath;
import org.jetbrains.kotlin.test.JUnit3RunnerWithInners;
import org.jetbrains.kotlin.test.KotlinTestUtils;
import org.jetbrains.kotlin.test.TargetBackend;
import org.jetbrains.kotlin.test.TestMetadata;
import org.junit.runner.RunWith;

import java.io.File;
import java.util.regex.Pattern;

/** This class is generated by {@link org.jetbrains.kotlin.generators.tests.TestsPackage}. DO NOT MODIFY MANUALLY */
@SuppressWarnings("all")
@TestMetadata("nj2k/testData/nullabilityAnalysis")
@TestDataPath("$PROJECT_ROOT")
@RunWith(JUnit3RunnerWithInners.class)
public class NullabilityAnalysisTestGenerated extends AbstractNullabilityAnalysisTest {
    private void runTest(String testDataFilePath) throws Exception {
        KotlinTestUtils.runTest(this::doTest, TargetBackend.ANY, testDataFilePath);
    }

    public void testAllFilesPresentInNullabilityAnalysis() throws Exception {
        KotlinTestUtils.assertAllTestsPresentByMetadata(this.getClass(), new File("nj2k/testData/nullabilityAnalysis"), Pattern.compile("^(.+)\\.kt$"), TargetBackend.ANY, true);
    }

    @TestMetadata("compareWithNull.kt")
    public void testCompareWithNull() throws Exception {
        runTest("nj2k/testData/nullabilityAnalysis/compareWithNull.kt");
    }

    @TestMetadata("forcedNullability.kt")
    public void testForcedNullability() throws Exception {
        runTest("nj2k/testData/nullabilityAnalysis/forcedNullability.kt");
    }

    @TestMetadata("functionTypeParameterNullability.kt")
    public void testFunctionTypeParameterNullability() throws Exception {
        runTest("nj2k/testData/nullabilityAnalysis/functionTypeParameterNullability.kt");
    }

    @TestMetadata("functions.kt")
    public void testFunctions() throws Exception {
        runTest("nj2k/testData/nullabilityAnalysis/functions.kt");
    }

    @TestMetadata("loops.kt")
    public void testLoops() throws Exception {
        runTest("nj2k/testData/nullabilityAnalysis/loops.kt");
    }

    @TestMetadata("nullAsAssignment.kt")
    public void testNullAsAssignment() throws Exception {
        runTest("nj2k/testData/nullabilityAnalysis/nullAsAssignment.kt");
    }

    @TestMetadata("nullAsInitializer.kt")
    public void testNullAsInitializer() throws Exception {
        runTest("nj2k/testData/nullabilityAnalysis/nullAsInitializer.kt");
    }

    @TestMetadata("smartCast.kt")
    public void testSmartCast() throws Exception {
        runTest("nj2k/testData/nullabilityAnalysis/smartCast.kt");
    }

    @TestMetadata("spreadExpression.kt")
    public void testSpreadExpression() throws Exception {
        runTest("nj2k/testData/nullabilityAnalysis/spreadExpression.kt");
    }

    @TestMetadata("superMethod.kt")
    public void testSuperMethod() throws Exception {
        runTest("nj2k/testData/nullabilityAnalysis/superMethod.kt");
    }

    @TestMetadata("typeCast.kt")
    public void testTypeCast() throws Exception {
        runTest("nj2k/testData/nullabilityAnalysis/typeCast.kt");
    }

    @TestMetadata("typeParameters.kt")
    public void testTypeParameters() throws Exception {
        runTest("nj2k/testData/nullabilityAnalysis/typeParameters.kt");
    }
}
